/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.enums.EnumElementrole;
import de.ship.db.enums.EnumRawschema;
import de.ship.db.tables.TCoreElementHierarchy.TCoreElementHierarchyPath;
import de.ship.db.tables.records.TCoreElementroleRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreElementrole extends TableImpl<TCoreElementroleRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_elementrole</code>
     */
    public static final TCoreElementrole T_CORE_ELEMENTROLE = new TCoreElementrole();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreElementroleRecord> getRecordType() {
        return TCoreElementroleRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_elementrole.lastchange</code>.
     */
    public final TableField<TCoreElementroleRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_core_elementrole.pk</code>.
     */
    public final TableField<TCoreElementroleRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_core_elementrole.fk_element</code>.
     * reference to hierarchy
     */
    public final TableField<TCoreElementroleRecord, Integer> FK_ELEMENT = createField(DSL.name("fk_element"), SQLDataType.INTEGER.nullable(false), this, "reference to hierarchy");

    /**
     * The column <code>common_dd.t_core_elementrole.elementrole</code>. role of
     * element
     */
    public final TableField<TCoreElementroleRecord, EnumElementrole> ELEMENTROLE = createField(DSL.name("elementrole"), SQLDataType.VARCHAR.nullable(false).asEnumDataType(EnumElementrole.class), this, "role of element");

    /**
     * The column <code>common_dd.t_core_elementrole.rawschema</code>. rawschema
     * of study of element
     */
    public final TableField<TCoreElementroleRecord, EnumRawschema> RAWSCHEMA = createField(DSL.name("rawschema"), SQLDataType.VARCHAR.nullable(false).asEnumDataType(EnumRawschema.class), this, "rawschema of study of element");

    private TCoreElementrole(Name alias, Table<TCoreElementroleRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreElementrole(Name alias, Table<TCoreElementroleRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_elementrole</code> table
     * reference
     */
    public TCoreElementrole(String alias) {
        this(DSL.name(alias), T_CORE_ELEMENTROLE);
    }

    /**
     * Create an aliased <code>common_dd.t_core_elementrole</code> table
     * reference
     */
    public TCoreElementrole(Name alias) {
        this(alias, T_CORE_ELEMENTROLE);
    }

    /**
     * Create a <code>common_dd.t_core_elementrole</code> table reference
     */
    public TCoreElementrole() {
        this(DSL.name("t_core_elementrole"), null);
    }

    public <O extends Record> TCoreElementrole(Table<O> path, ForeignKey<O, TCoreElementroleRecord> childPath, InverseForeignKey<O, TCoreElementroleRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_ELEMENTROLE);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCoreElementrolePath extends TCoreElementrole implements Path<TCoreElementroleRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCoreElementrolePath(Table<O> path, ForeignKey<O, TCoreElementroleRecord> childPath, InverseForeignKey<O, TCoreElementroleRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCoreElementrolePath(Name alias, Table<TCoreElementroleRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCoreElementrolePath as(String alias) {
            return new TCoreElementrolePath(DSL.name(alias), this);
        }

        @Override
        public TCoreElementrolePath as(Name alias) {
            return new TCoreElementrolePath(alias, this);
        }

        @Override
        public TCoreElementrolePath as(Table<?> alias) {
            return new TCoreElementrolePath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TCoreElementroleRecord, Integer> getIdentity() {
        return (Identity<TCoreElementroleRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TCoreElementroleRecord> getPrimaryKey() {
        return Keys.PK_CORE_ELEMENTROLE;
    }

    @Override
    public List<UniqueKey<TCoreElementroleRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_CORE_ELEMENTROLE);
    }

    @Override
    public List<ForeignKey<TCoreElementroleRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_CORE_ELEMENTROLE__FK_CORE_ELEMENTROLE);
    }

    private transient TCoreElementHierarchyPath _tCoreElementHierarchy;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_element_hierarchy</code> table.
     */
    public TCoreElementHierarchyPath tCoreElementHierarchy() {
        if (_tCoreElementHierarchy == null)
            _tCoreElementHierarchy = new TCoreElementHierarchyPath(this, Keys.T_CORE_ELEMENTROLE__FK_CORE_ELEMENTROLE, null);

        return _tCoreElementHierarchy;
    }

    @Override
    public TCoreElementrole as(String alias) {
        return new TCoreElementrole(DSL.name(alias), this);
    }

    @Override
    public TCoreElementrole as(Name alias) {
        return new TCoreElementrole(alias, this);
    }

    @Override
    public TCoreElementrole as(Table<?> alias) {
        return new TCoreElementrole(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreElementrole rename(String name) {
        return new TCoreElementrole(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreElementrole rename(Name name) {
        return new TCoreElementrole(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreElementrole rename(Table<?> name) {
        return new TCoreElementrole(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreElementrole where(Condition condition) {
        return new TCoreElementrole(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreElementrole where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreElementrole where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreElementrole where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreElementrole where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreElementrole where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreElementrole where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreElementrole where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreElementrole whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreElementrole whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
